Merge branch 'master' into rorcz
[girocco.git] / jobd / update.sh
blob40dc590878e4ebe6715d81040c976cd2a62dabb3
1 #!/bin/bash
3 . @basedir@/shlib.sh
5 # date -R is linux-only, POSIX equivalent is '+%a, %d %b %Y %T %z'
6 datefmt='+%a, %d %b %Y %T %z'
8 # darcs fast-export | git fast-import with error handling
9 git_darcs_fetch() {
10 "$cfg_basedir"/bin/darcs-fast-export --export-marks=$(pwd)/dfe-marks --import-marks=$(pwd)/dfe-marks "$1" | \
11 git fast-import --export-marks=$(pwd)/gfi-marks --import-marks=$(pwd)/gfi-marks
12 [ ${PIPESTATUS[0]} = 0 -a ${PIPESTATUS[1]} = 0 ]
13 return $?
16 # bzr fast-export | git fast-import with error handling
17 git_bzr_fetch() {
18 bzr fast-export --export-marks=$(pwd)/dfe-marks --import-marks=$(pwd)/dfe-marks "$1" | \
19 git fast-import --export-marks=$(pwd)/gfi-marks --import-marks=$(pwd)/gfi-marks
20 [ ${PIPESTATUS[0]} = 0 -a ${PIPESTATUS[1]} = 0 ]
21 return $?
23 set -e
24 trap 'if [ $? != 0 ]; then echo "update failed dir: $PWD" >&2; fi; rm -f "$bang_log"' EXIT
26 proj="$1"
27 cd "$cfg_reporoot/$proj.git"
29 if check_interval lastrefresh $cfg_min_mirror_interval; then
30 progress "= [$proj] update skip (last at $(config_get lastrefresh))"
31 exit 0
33 progress "+ [$proj] update (`date`)"
35 bang_setup
36 bang_once=1
37 bang_action="update"
39 url="$(config_get baseurl)"
40 mail="$(config_get owner)"
42 bang git for-each-ref --format '%(refname) %(objectname)' >.refs-before
44 case "$url" in
45 svn://* | svn+http://* | svn+https://*)
46 GIT_DIR=. bang git svn fetch
47 GIT_DIR=. bang git fetch
49 darcs://*)
50 httpurl="${url/darcs:\/\//http://}"
51 bang git_darcs_fetch "$httpurl"
53 bzr://*)
54 bzrurl="${url#bzr://}"
55 bang git_bzr_fetch "$bzrurl"
58 [ "$url" = "$(config_get remote.origin.url)" ] || bang config_set_raw remote.origin.url "$url"
59 GIT_SSL_NO_VERIFY=1 bang git remote update
60 bang git remote prune origin
62 esac
64 bang git update-server-info
65 bang config_set lastrefresh "$(date "$datefmt")"
67 # Look at which refs changed and trigger ref-change for these
68 bang git for-each-ref --format '%(refname) %(objectname)' >.refs-after
69 sockpath="$cfg_chroot/etc/taskd.socket"
70 if [ -S "$sockpath" ] && ! cmp -s .refs-before .refs-after; then
71 join -j 1 .refs-before .refs-after |
72 while read ref old new; do
73 [ "$old" != "$new" ] || continue
74 echo "ref-change -1 $proj $old $new $ref" | nc.openbsd -w 1 -U "$sockpath"
75 done
76 join -j 1 -v 1 .refs-before .refs-after |
77 while read ref old; do
78 echo "ref-change -1 $proj $old 0000000000000000000000000000000000000000 $ref" | nc.openbsd -w 1 -U "$sockpath"
79 done
80 join -j 1 -v 2 .refs-before .refs-after |
81 while read ref new; do
82 echo "ref-change -1 $proj 0000000000000000000000000000000000000000 $new $ref" | nc.openbsd -w 1 -U "$sockpath"
83 done
86 rm -f .refs-before .refs-after
88 if [ -e .banged ]; then
89 echo "$proj update succeeded - failure recovery" | mail -s "[$cfg_name] $proj update succeeded" "$mail,$cfg_admin"
90 rm .banged
93 progress "- [$proj] update (`date`)"